/* Copyright (C) 2012 Rudra Banerjee*/

/*
This file is part of mkbib.

mkbib is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

mkbib is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with mkbib.  If not, see <http://www.gnu.org/licenses/>.

*/

#include <gtk/gtk.h>
#include <glib.h>
#include <string.h>
/* #include <stdio.h>
 * #include <stdlib.h>
 * #include <sys/types.h>
 * #include <sys/stat.h>
 * #include <gdk/gdk.h>
 * #include <gdk/gdkkeysyms.h>
 */
#include "main.h"
GtkWidget *flabel;
char *filename;
void caution();
GtkListStore *store;
GtkTreeIter siter;


void activate_func(GtkWidget *widget, gpointer data) {
    Entries *e = (Entries*) data;
//    GtkTextMark *mark;
//    GtkTextIter iter;
    const gchar *strcombo, *strkey, *strAuth, *strEditor, *strTitle,
            *strPub, *strVol, *strIss, *strPage, *strMon, *strNote,
            *strKey, *strYear, *strAdd, *strEdition,
            *strJournal, *strSeries, *strBooktitle, *strOrg,
            *strChap, *strSchool;
                       
    strcombo = gtk_combo_box_text_get_active_text(GTK_COMBO_BOX_TEXT(e->combo));
    strkey = gtk_entry_get_text(GTK_ENTRY(e->entry1));
    strAuth = gtk_entry_get_text(GTK_ENTRY(e->entryAuth));
    strEditor = gtk_entry_get_text(GTK_ENTRY(e->entryEditor));
    strTitle = gtk_entry_get_text(GTK_ENTRY(e->entryTitle));
    strPub = gtk_entry_get_text(GTK_ENTRY(e->entryPub));
    strVol = gtk_entry_get_text(GTK_ENTRY(e->entryVol));
    strIss = gtk_entry_get_text(GTK_ENTRY(e->entryIss));
    strPage = gtk_entry_get_text(GTK_ENTRY(e->entryPage));
    strMon = gtk_entry_get_text(GTK_ENTRY(e->entryMon));
    strNote = gtk_entry_get_text(GTK_ENTRY(e->entryNote));
    strKey = gtk_entry_get_text(GTK_ENTRY(e->entryKey));
    strYear = gtk_entry_get_text(GTK_ENTRY(e->entryYear));
    strAdd = gtk_entry_get_text(GTK_ENTRY(e->entryAdd));
    strEdition = gtk_entry_get_text(GTK_ENTRY(e->entryEdition));
    strJournal = gtk_entry_get_text(GTK_ENTRY(e->entryJournal));
    strSeries = gtk_entry_get_text(GTK_ENTRY(e->entrySeries));
    strBooktitle = gtk_entry_get_text(GTK_ENTRY(e->entryBooktitle));
    strOrg = gtk_entry_get_text(GTK_ENTRY(e->entryOrg));
    strSchool = gtk_entry_get_text(GTK_ENTRY(e->entrySchool));
    strChap = gtk_entry_get_text(GTK_ENTRY(e->entryChap));

//    mark = gtk_text_buffer_get_insert (textbuffer);

if(strcmp (strcombo,"==Entry Type==")==0){
	char 	*err_entry="Select Entry Type";
        caution(err_entry);
}
else if(strcmp(strkey,"")==0){
  char *err_key="Select Key";
  caution(err_key);
}
else{
  gtk_list_store_append(store, &siter);
  gtk_list_store_set(store, &siter,
                      COL_BIB_KEY, strkey,
                      COL_BIB_TYPE, strcombo,
                      COL_BIB_NAME, strAuth,
                      COL_BIB_YEAR, strYear,
                      COL_BIB_PUB, strTitle,
                      -1);

/*
 * Create the file
 */
  FILE *fop = fopen(filename, "a" );
  if (!fop){
    filename="Untitled.bib";
    fop= fopen(filename,"a");
  }
  gtk_label_set_text(GTK_LABEL(flabel), filename);
  g_fprintf( fop, "@%s{%s,\n", strcombo, strkey );
  if( strlen(strAuth)!=0)
    g_fprintf( fop, "\tAuthor=\"%s\",\n", strAuth);
  if( strlen(strEditor)!=0)
    g_fprintf( fop, "\tEditor=\"%s\",\n", strEditor);
  if( strlen(strTitle)!=0)
    g_fprintf( fop, "\tTitle=\"%s\",\n", strTitle);
  if( strlen(strPub)!=0)
    g_fprintf( fop, "\tPublisher=\"%s\",\n", strPub);
  if( strlen(strVol)!=0)
    g_fprintf( fop, "\tVolume=\"%s\",\n", strVol);
  if( strlen(strIss)!=0)
    g_fprintf( fop, "\tIssue=\"%s\",\n", strIss);
  if( strlen(strPage)!=0)
    g_fprintf( fop, "\tPage=\"%s\",\n", strPage);
  if( strlen(strMon)!=0)
    g_fprintf( fop, "\tMonth=\"%s\",\n", strMon);
  if( strlen(strNote)!=0)
    g_fprintf( fop, "\tNote=\"%s\",\n", strNote);
  if( strlen(strKey)!=0)
    g_fprintf( fop, "\tKey=\"%s\",\n", strKey);
  if( strlen(strYear)!=0)
    g_fprintf( fop, "\tYear=\"%s\",\n", strYear);
  if( strlen(strAdd)!=0)
    g_fprintf( fop, "\tAdd=\"%s\",\n", strAdd);
  if( strlen(strEdition)!=0)
    g_fprintf( fop, "\tEdition=\"%s\",\n", strEdition);
  if( strlen(strJournal)!=0)
    g_fprintf( fop, "\tJournal=\"%s\",\n", strJournal);
  if( strlen(strSeries)!=0)
    g_fprintf( fop, "\tSeries=\"%s\",\n", strSeries);
  if( strlen(strBooktitle)!=0)
    g_fprintf( fop, "\tBooktitle=\"%s\",\n", strBooktitle);
  if( strlen(strOrg)!=0)
    g_fprintf( fop, "\tOrg=\"%s\",\n", strOrg);
  if( strlen(strChap)!=0)
    g_fprintf( fop, "\tChap=\"%s\",\n", strChap);
  if( strlen(strSchool)!=0)
    g_fprintf( fop, "\tSchool=\"%s\",\n", strSchool);
    g_fprintf( fop, "}\n");
    fclose(fop);
}
gtk_entry_set_text(GTK_ENTRY(e->entry1),"");
gtk_entry_set_text(GTK_ENTRY(e->entryAuth),"");
gtk_entry_set_text(GTK_ENTRY(e->entryEditor),"");
gtk_entry_set_text(GTK_ENTRY(e->entryTitle),"");
gtk_entry_set_text(GTK_ENTRY(e->entryPub),"");
gtk_entry_set_text(GTK_ENTRY(e->entryVol),"");
gtk_entry_set_text(GTK_ENTRY(e->entryIss),"");
gtk_entry_set_text(GTK_ENTRY(e->entryPage),"");
gtk_entry_set_text(GTK_ENTRY(e->entryMon),"");
gtk_entry_set_text(GTK_ENTRY(e->entryNote),"");
gtk_entry_set_text(GTK_ENTRY(e->entryKey),"");
gtk_entry_set_text(GTK_ENTRY(e->entryYear),"");
gtk_entry_set_text(GTK_ENTRY(e->entryAdd),"");
gtk_entry_set_text(GTK_ENTRY(e->entryEdition),"");
gtk_entry_set_text(GTK_ENTRY(e->entryJournal),"");
gtk_entry_set_text(GTK_ENTRY(e->entrySeries),"");
gtk_entry_set_text(GTK_ENTRY(e->entryBooktitle),"");
gtk_entry_set_text(GTK_ENTRY(e->entryOrg),"");
gtk_entry_set_text(GTK_ENTRY(e->entryChap),"");
gtk_entry_set_text(GTK_ENTRY(e->entrySchool),"");
}

